#ifndef __NAA3D_FX_METAGRID_H__
#define __NAA3D_FX_METAGRID_H__

class NaaMetaBall;

class NaaMetaGrid : public NaaFX
{
	NAA_DECL_CLASSID(NaaMetaGrid,NaaFX);
protected:

	NaaBBox bbgrid;
	int nx,ny,nz;

	NaaPoint3D p0;
	NaaPoint3D p1;
	NaaVector3D dp;

	NaaMetaBall * l_mb;
	int n_mb;

	struct Cell
	{
		float d;
		float r,g,b;
	};
	//typedef Cell* Plan;

	class Plan
	{
	public:
		Cell *ptr;
		void *data;

		void Init(int nx,int ny)
		{
			Free();
			ptr=new Cell[nx*ny];
		}

		void Free()
		{
			if (ptr!=NULL)
			{
				delete[] ptr;
				ptr=NULL;
			}
		}

		Plan() : ptr(NULL), data(NULL) {}
		Plan(int nx,int ny) : ptr(NULL), data(NULL)
		{
			Init(nx,ny);
		}
		~Plan()
		{
			Free();
		}
	};

	Plan plan_0;
	Plan plan_1;

	NaaPoint3D plight;

	NaaPoint3D pl_cam;

	virtual void GridCalc_CallBack0(int z,float pz,Plan *p) // Premier Plan
	{}
	virtual void GridCalc_CallBack(int z,float pz,Plan *p0,Plan *p1)=0; // Plans intermdiaires
	virtual void GridCalc_CallBack1(int z,float pz,Plan *p) // Dernier Plan
	{}

	void GridCalc();

	float txtu0,txtv0;

	void CalcNormal(NaaVertex1 *v);

public:
	NaaMetaGrid(NaaNObj *o,NaaFXParams *param);
	~NaaMetaGrid();

	void AddMeta(NaaMetaBall *obj);

	void CalcBBox(NaaBBox *b);

	virtual void Aff();
	virtual bool CalcAnim(float t,float dt);
	virtual bool CalcAnim2(float t,float dt);

	void ApplyLightEnv(NaaLightEnv *le);
	// applique l'environement lumineux  l'objet

};

#include "Naa3D_VBall.h"

class NaaMetaGrid_VBall : public NaaMetaGrid
{
	NAA_DECL_CLASSID(NaaMetaGrid_VBall,NaaMetaGrid);
public:

	NaaVBall vb;

	int first;

	void AffVB();

	NaaMetaGrid_VBall(NaaNObj *o,NaaFXParams *param);
	~NaaMetaGrid_VBall();

	virtual void Aff();

	void GridCalc_CallBack(int z,float pz,Plan *p0,Plan *p1); // Plans intermdiaires

};

#endif
