// Naa3D_Test1.cpp : Defines the entry point for the application.
//

#include <stdlib.h>
#include <math.h>

#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers

#include <windows.h>

#include <gl/gl.h>

#pragma comment(lib,"opengl32.lib")

#include "../NaaDef.h"

#include "../Naa3D_Render/Naa3D_Render.h"

#include "../Naa3D_Render/Naa3D_VBallText.h"

#include "../Naa3D_Render/Naa3D_VBall.h"

#include "../TankTest01/MouseMan.h"

#define WINTITLE "Hufo's Vector Ballz"

HWND g_hwnd;
HINSTANCE g_hinst;


void NaaAffVBall(NaaVector3D pos,float size,NaaColor4b color
                ,NaaVBallTexture::VBallPos *tpos,NaaTexture *txt)
{
	NaaSprite s;
	s.p=pos*10;
	s.c=color;
	s.sx=size*10;
	s.sy=size*10;
	s.txt=txt->AddRef();
	s.t[0]=tpos->t[0];
	s.t[1]=tpos->t[1];
	s.type=NaaSprite::DistFade;
	NaaAffSprite(&s);
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{

	g_hinst=hInstance;

	MSG msg;

	if (NaaAffChooseAPI(hInstance)==r_err)
	{
		MessageBox(NULL,"fonction NaaAffChooseAPI","Erreur :-(",MB_ICONERROR|MB_OK);
		return 1;
	}

	NaaVertex1 v[4];
	NaaFace f[2];
	f[0].v[0]=&v[0]; f[0].v[1]=&v[1]; f[0].v[2]=&v[2];
	f[1].v[0]=&v[2]; f[1].v[1]=&v[1]; f[1].v[2]=&v[3];
	v[0].p=NaaPoint3D( 0, 0,10); v[0].c=NaaRGB(255,255,255);
	v[1].p=NaaPoint3D(10, 0,10); v[1].c=NaaRGB(255,255,255);
	v[2].p=NaaPoint3D( 0,10,10); v[2].c=NaaRGB(255,255,255);
	v[3].p=NaaPoint3D(10,10,10); v[3].c=NaaRGB(255,255,255);
	v[0].t[0].u=0.0f; v[0].t[0].v=1.0f;
	v[1].t[0].u=1.0f; v[1].t[0].v=1.0f;
	v[2].t[0].u=0.0f; v[2].t[0].v=0.0f;
	v[3].t[0].u=1.0f; v[3].t[0].v=0.0f;

	NaaMaterial m;

	NaaVBallTexture *vbtext=new NaaVBallTexture();
	vbtext->AddRef();
	m.ctxt.txt=vbtext;
	//m.ctxt.txt=NaaTextureNew("#flare",NaaTexture::Alpha);
	//m.flag=NaaMaterial::Double|NaaMaterial::Smooth|NaaMaterial::Color|NaaMaterial::CTxt;
	m.flag=NaaMaterial::Double|NaaMaterial::CTxt; //|NaaMaterial::Color;
	m.color=NaaRGB(255,255,255);

	//NaaVBall::Init();

	NaaVBall vb;

	NaaMaterial m_line;
	m_line.flag=NaaMaterial::Double; //|NaaMaterial::Color;
	m_line.color=NaaRGB(255,255,255);

	NaaXForm xf;
	xf.type=NaaXForm::TSStd|NaaXForm::Euler;

	if (NaaAffInitDef(NULL,&g_hwnd)==r_err)
	{
		MessageBox(NULL,"fonction NaaAffInit","Erreur :-(",MB_ICONERROR|MB_OK);
		NaaAffReleaseAPI();
		return 1;
	}
	SetWindowText(g_hwnd,WINTITLE);

#ifndef NOTEXTURE
	if (NaaTextureLoad(m.ctxt.txt)==0)
	{
		NaaAffQuit();
		MessageBox(NULL,"fonction NaaTextureLoad","Erreur :-(",MB_ICONERROR|MB_OK);
		NaaAffReleaseAPI();
		return 1;
	}
	if (NaaTextureLoadAll()==r_err)
	{
		NaaAffQuit();
		MessageBox(NULL,"fonction NaaTextureLoadAll","Erreur :-(",MB_ICONERROR|MB_OK);
		NaaAffReleaseAPI();
		return 1;
	}
/*
	if (NaaVBall::Load()==r_err)
	{
		NaaAffQuit();
		MessageBox(NULL,"fonction NaaVBall::Load","Erreur :-(",MB_ICONERROR|MB_OK);
		NaaAffReleaseAPI();
		return 1;
	}
*/
#endif

	bool ms=(MouseManInit(g_hinst,g_hwnd)==r_ok);

	NaaPoint3D vb_pos(0,0,1);

	vb.p=NaaVector3D(10,0,10);
	vb.c=NaaRGB(255,255,0);
	vb.SetSize(1.0f);

	while(1)
	{
		if(PeekMessage(&msg,0,0,0,PM_NOREMOVE))
		{
			if(!GetMessage(&msg,0,0,0))
				break;
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else
		{

			if (ms)
			{
				int dx,dy;
				MouseManGetDepl(&dx,&dy);

				xf.rot_euler.y+=dx*(float)(PI/400);
				xf.rot_euler.x+=dy*(float)(PI/400);
			}
			else
			{
				xf.rot_euler+=NaaVector3D(0,Naa3D_AngFromDEG(1),0);
			}
			xf.Recalc();
			NaaVector3D vlight(0,0,-1);
			xf.Apply(NaaVector3D(0,0,-1),&vlight);
			NaaVBallTexture::VBallPos *tpos=vbtext->GetVBallFromLight(vlight);
			//v[0].t[0].u=tpos->t[0].u; v[0].t[0].v=tpos->t[0].v;
			//v[1].t[0].u=tpos->t[1].u; v[1].t[0].v=tpos->t[0].v;
			//v[2].t[0].u=tpos->t[0].u; v[2].t[0].v=tpos->t[1].v;
			//v[3].t[0].u=tpos->t[1].u; v[3].t[0].v=tpos->t[1].v;
			NaaAffBegin();

			NaaVertex1 v_line[2];
			NaaVertex1 * tv_line[2]={v_line+0,v_line+1};
			v_line[0].p=vb_pos*10;
			v_line[1].p=v_line[0].p+vlight*2;
			NaaAffMaterial(&m_line);
			NaaAffLine(tv_line,2);

			glAlphaFunc(GL_GREATER,0.0f);
			glEnable(GL_ALPHA_TEST);

			NaaAffVBall(vb_pos,0.1f,NaaRGB(255,255,0),tpos,vbtext);

			vb.ApplyLight(vlight);
			vb.Aff();

			glDisable(GL_ALPHA_TEST);

			for (int face=0;face<6;face++)
			{
				NaaVector3D vf((face&1)?-0.66f:-1.33f,0.9f-0.66f*(face/2),1.0f);
				NaaColor4b color;
				color.r=(face==0 || face==3 || face==5)?192:128;
				color.g=(face==2 || face==1 || face==5)?192:128;
				color.b=(face==4 || face==1 || face==3)?192:128;
				for (int v=0;v<NaaVBallTexture::FACE_SIZE;v++)
				{
					NaaVector3D pos=vf;
					for (int u=0;u<NaaVBallTexture::FACE_SIZE;u++)
					{
						NaaVBallTexture::VBallPos *tp=&(vbtext->tpos[face][v][u]);
						NaaAffVBall(pos,0.5f/NaaVBallTexture::FACE_SIZE,(tp==tpos)?NaaRGB(255,255,255):color,tp,vbtext);

						pos.x+=0.5f/NaaVBallTexture::FACE_SIZE;

					}
					vf.y-=0.5f/NaaVBallTexture::FACE_SIZE;
				}
			}

			//NaaAffMaterial(&m);
			//NaaAffNFace(f,2);
			NaaAffEnd();
		}
	}
	if (ms)
		MouseManQuit();
	NaaAffQuit();
	NaaAffReleaseAPI();
	return msg.wParam;
}
